# Instruction to build huskylib

Please read the files (especially README.Makefiles) in the
husky-common (huskybse) package FIRST!

## Table of Contents
- [Prebuild](#prebuild)
- [Build](#build)
  - [Compiling and installing with the standard Makefile and huskymak.cfg](#compiling-and-installing-with-the-standard-makefile-and-huskymakcfg)
  - [Compiling with the Legacy Makefiles](#compiling-with-the-legacy-makefiles)
  - [Compiling and installing using Cmake](#compiling-and-installing-using-cmake)
- [Afterbuild actions](#afterbuild-actions)

## Prebuild

- Put the huskylib package in the directory where the other packages of fido
  husky reside:
   
  - unix, beos, possible cygwin:
      ```text
      /usr/src/packages/        -> huskybse/
                                -> huskylib/
                                -> smapi/
                                -> fidoconfig/
                                -> hpt/
                                -> htick/
                                ...some other
      ```
   - windows, dos, os/2 & etc:
      ```text
         d:\husky\              -> huskylib\
                                -> smapi\
                                -> fidoconf\
                                -> hpt\
                                -> htick\
                                ...some other
      ```
## Build 

### Compiling and installing with the standard Makefile and huskymak.cfg

require huskymak.cfg (see huskybse), unixes only:
```sh
   $ make
   $ make install
```
### Compiling with the Legacy Makefiles

unix:
```sh
   $ make -f makefile.lnx
   $ make -f makefile.lnx install
```
dos:
```sh
   d:\husky\huskylib>make -f makefile.djg
```
 ### Compiling and installing using Cmake
 
- Run CMake to configure the build tree.
   ```sh
      $ cmake -H. -Bbuild -DBUILD_SHARED_LIBS=OFF
   ```
- Afterwards, generated files can be used to compile the project.
   ```sh
      $ cmake --build build
   ```
- Make distrib rpm, deb,tgz (optional)
   ```sh
      $ cpack -G RPM --config build/CPackConfig.cmake
      $ cpack -G DEB --config build/CPackConfig.cmake
      $ cpack -G TGZ --config build/CPackConfig.cmake
   ```

- Install the built files (optional).
   ```sh
      $ cmake --build build --target install
   ```
## Afterbuild actions

- (For UNIXes only) Ensure /usr/local/lib/ is in /etc/ld.so.conf
- (For UNIXes only) Execute ldconfig as root

You're ready. Now you can install software which uses huskylib.

